package com.andrewjorgensen;

import backtype.storm.Config;
import backtype.storm.StormSubmitter;
import backtype.storm.generated.AlreadyAliveException;
import backtype.storm.generated.InvalidTopologyException;
import backtype.storm.topology.TopologyBuilder;
import com.twitter.heron.simulator.Simulator;
import org.apache.commons.cli.*;

public class TopologyMain {
    public static void main(String... args) throws AlreadyAliveException, InvalidTopologyException, ParseException {
        Options options = new Options();
        options.addOption("l", "local_mode", false, "toggle local mode");

        CommandLineParser parser = new DefaultParser();
        CommandLine cmd = parser.parse(options, args);


        TopologyBuilder builder = new TopologyBuilder();

        builder.setSpout("emitter-spout", new EmitterSpout());
        builder.setBolt("reader-bolt", new ReaderBolt())
                .shuffleGrouping("emitter-spout");

        Config config = new Config();

        if (cmd.hasOption("local_mode")) {
            new Simulator().submitTopology("heron-kryo", config, builder.createTopology().getStormTopology());
        } else {
            StormSubmitter.submitTopology("heron-kryo", config, builder.createTopology());
        }
    }
}
